From: Josh Hilke <jrhilke@google.com>
To: Alex Williamson <alex@shazbot.org>, David Matlack <dmatlack@google.com>
Cc: Sean Christopherson <seanjc@google.com>,
Vipin Sharma <vipinsh@google.com>,
kvm@vger.kernel.org, linux-kernel@vger.kernel.org,
Josh Hilke <jrhilke@google.com>
Subject: [PATCH v3] vfio: selftests: Find devices that have VFIO selftest drivers
Date: Fri, 15 May 2026 03:07:58 +0000 [thread overview]
Message-ID: <20260515030758.1203256-1-jrhilke@google.com> (raw)
Add a new script, list_devices.sh, which prints out the
segment:bus:device.function (SBDF) numbers and names of devices on a machine that have a
VFIO selftest driver. This makes it easier to determine if the system is
capable of running VFIO selftests.
Includes a -q (quiet) argument which prints just the SBDFs so that the
output can be piped into tools/testing/selftests/vfio/script/setup.sh to
bind the devices to VFIO to use in VFIO selftests.
Examples:
$ ./list_devices.sh
0000:6a:01.0 - Intel SPR DSA (8086:0b25)
0000:6f:01.0 - Intel SPR DSA (8086:0b25)
0000:74:01.0 - Intel SPR DSA (8086:0b25)
0000:79:01.0 - Intel SPR DSA (8086:0b25)
0000:e7:01.0 - Intel SPR DSA (8086:0b25)
0000:ec:01.0 - Intel SPR DSA (8086:0b25)
0000:f1:01.0 - Intel SPR DSA (8086:0b25)
0000:f6:01.0 - Intel SPR DSA (8086:0b25)
$ ./list_devices.sh -q
0000:6a:01.0
0000:6f:01.0
0000:74:01.0
0000:79:01.0
0000:e7:01.0
0000:ec:01.0
0000:f1:01.0
0000:f6:01.0
Suggested-by: Sean Christopherson <seanjc@google.com>
Signed-off-by: Josh Hilke <jrhilke@google.com>
---
Changelog:
v3:
- Show the names of the devices (Sean)
v2:
- Move the functionality to discover devices from setup.sh into its own script (Sean)
- Omit the patch which automates binding devices to VFIO (Sean, David)
v2: https://lore.kernel.org/kvm/20260414230943.41198-2-jrhilke@google.com/
v1: https://lore.kernel.org/kvm/20260409015139.2800185-1-jrhilke@google.com/
tools/testing/selftests/vfio/Makefile | 1 +
.../selftests/vfio/scripts/list_devices.sh | 46 +++++++++++++++++++
2 files changed, 47 insertions(+)
create mode 100755 tools/testing/selftests/vfio/scripts/list_devices.sh
diff --git a/tools/testing/selftests/vfio/Makefile b/tools/testing/selftests/vfio/Makefile
index 0684932d91bf..777f91f09057 100644
--- a/tools/testing/selftests/vfio/Makefile
+++ b/tools/testing/selftests/vfio/Makefile
@@ -15,6 +15,7 @@ TEST_GEN_PROGS += vfio_pci_driver_test
TEST_FILES += scripts/cleanup.sh
TEST_FILES += scripts/lib.sh
+TEST_FILES += scripts/list_devices.sh
TEST_FILES += scripts/run.sh
TEST_FILES += scripts/setup.sh
diff --git a/tools/testing/selftests/vfio/scripts/list_devices.sh b/tools/testing/selftests/vfio/scripts/list_devices.sh
new file mode 100755
index 000000000000..8e7cbe5b7449
--- /dev/null
+++ b/tools/testing/selftests/vfio/scripts/list_devices.sh
@@ -0,0 +1,46 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+# List of devices which have a VFIO selftest driver
+readonly DEVICES=(
+ "8086:0b25,Intel SPR DSA"
+ "8086:11fb,Intel GNR-D DSA"
+ "8086:1212,Intel DR DSA"
+ "8086:0cf8,Intel CBDMA"
+)
+
+QUIET=false
+while getopts "q" opt; do
+ case $opt in
+ q) QUIET=true ;;
+ \?) echo "Usage: $0 [-q]" >&2; exit 1 ;;
+ esac
+done
+
+# Print the segment:bus:device.function numbers of PCI devices that can be used
+# to run VFIO selftests.
+function main() {
+ local id_name
+ local name
+ local bdfs
+ local bdf
+ local id
+
+ for id_name in "${DEVICES[@]}"; do
+ IFS=',' read -r id name <<< "$id_name"
+ bdfs=$(lspci -D -d "${id}" | awk '{print $1}')
+
+ [[ -z $bdfs ]] && continue
+
+ if [ "$QUIET" = true ]; then
+ echo "${bdfs}"
+ continue
+ fi
+
+ while read -r bdf; do
+ echo "${bdf} - ${name} (${id})"
+ done <<< "$bdfs"
+ done
+}
+
+main
--
2.54.0.563.g4f69b47b94-goog
reply other threads:[~2026-05-15 3:08 UTC|newest]
Thread overview: [no followups] expand[flat|nested] mbox.gz Atom feed
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20260515030758.1203256-1-jrhilke@google.com \
--to=jrhilke@google.com \
--cc=alex@shazbot.org \
--cc=dmatlack@google.com \
--cc=kvm@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=seanjc@google.com \
--cc=vipinsh@google.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.